const jwt = require('jsonwebtoken')
const config = require('../configs/env')

module.exports = (opts) => (req, res, next) => {
  const options = {}
  options.whitelist = opts.whitelist || false
  if (options.whitelist && options.whitelist.indexOf(req.url) !== -1) {
    return next()
  }
  if (req.headers.token) {
    jwt.verify(req.headers.token, config.jwtSecret, function (err, decoded) {
      if (err) {
        return next(new Error('invalid token'))
      }
      return next()
    })
  } else {
    return next(new Error('token is mandatory'))
  }
}
