const fp = require('fastify-plugin')
const glob = require('glob')
const config = require('../configs/env')

let models = {}

const fastifyPostgres = (fastify, options = {}, next) => {
  const knex = require('knex')({
    client: 'pg',
    connection: {
      host: config.postgres.host,
      user: 'docker',
      password: 'docker',
      database: 'docker',
    },
    pool: {
      afterCreate: function (conn, done) {
        conn.query('SET timezone="UTC";', function (err) {
          if (err) {
            console.log(['postgres', 'Connect Error'], err)
            done(err, conn)
          } else {
            console.log(['postgres', 'info'], 'Postgres connected.')
            require('../postgres/tables')(knex)
            done(err, conn)
          }
        })
      },
    },
  })
  glob('../postgres/models/**/*.js', { cwd: __dirname }, (err, files) => {
    if (err) {
      throw err
    }
    for (let file of files) {
      const model = require(file)(knex, fastify)
      models[model.modelName] = model
    }
    fastify.decorateRequest('models', models)
    next()
  })
}

module.exports = fp(fastifyPostgres)
