const memberHandler = require('../handlers/member')
const memberSchema = require('../schemas/member')

module.exports = [
  {
    method: 'GET',
    url: '/members',
    handler: memberHandler.list,
    schema: memberSchema.list,
  },
  {
    method: 'GET',
    url: '/members/exists',
    handler: memberHandler.exists,
    schema: memberSchema.exists,
  },
  {
    method: 'POST',
    url: '/members/login',
    handler: memberHandler.login,
    schema: memberSchema.login,
  },
  {
    method: 'GET',
    url: '/members/:memberId',
    handler: memberHandler.get,
    schema: memberSchema.get,
  },
  {
    method: 'POST',
    url: '/members',
    handler: memberHandler.create,
    schema: memberSchema.create,
  },
  {
    method: 'PUT',
    url: '/members/:memberId',
    handler: memberHandler.update,
    schema: memberSchema.update,
  },
  {
    method: 'DELETE',
    url: '/members/:memberId',
    handler: memberHandler.remove,
    schema: memberSchema.remove,
  },
]
