const userHandler = require('../handlers/user')
const userSchema = require('../schemas/user')

module.exports = [
  {
    method: 'GET',
    url: '/users',
    handler: userHandler.list,
    schema: userSchema.list,
  },
  {
    method: 'POST',
    url: '/users/login',
    handler: userHandler.login,
    schema: userSchema.login,
  },
  {
    method: 'GET',
    url: '/users/:userId',
    handler: userHandler.get,
    schema: userSchema.get,
  },
  {
    method: 'POST',
    url: '/users',
    handler: userHandler.create,
    schema: userSchema.create,
  },
  {
    method: 'PUT',
    url: '/users/:userId',
    handler: userHandler.update,
    schema: userSchema.update,
  },
  {
    method: 'DELETE',
    url: '/users/:userId',
    handler: userHandler.remove,
    schema: userSchema.remove,
  },
]
