const fastify = require('fastify')()
const config = require('./configs/env')
const boom = require('./configs/boom')

fastify.decorate('boom', boom)

fastify.use(require('cors')())
// fastify.use(require('./middlewares/jwt-auth')(require('./configs/jwt-auth')))

// fastify.register(require('./modules/mongoose'))
fastify.register(require('./modules/postgres'))
fastify.register(require('./modules/jwt'), require('./configs/jwt'))
fastify.register(require('./modules/route'))

fastify.listen(config.port, function (err) {
  if (err) throw err
  console.log(`server listening on ${fastify.server.address().port}`)
})
